package rabbit.cache;

// $Id: CacheLoadTester.java,v 1.2 2005/08/03 17:00:41 robo Exp $

import java.io.*;

/** A small test program that creates a lot of entries in the cache. Used for profiling.
 */
public class CacheLoadTester {
    private CacheLoadTester () {
	// ignore.
    }
    
    public static void main (String[] args) {
	NCache cache = new NCache ("/tmp/cachetest", (long)10 * 1024 * 1024 * 1024); // 10 GB
	byte[] buf = "hello".getBytes ();
	for (int i = 0; i < 500000; i++) {
	    try {
		Integer ii = new Integer (i);
		NCacheEntry entry = cache.newEntry (ii);
		String fname = cache.getEntryName (entry.getId (), false);
		FileOutputStream fos = new FileOutputStream (fname);
		fos.write (buf);
		fos.close ();
		cache.addEntry (entry);
		if (i % 100 == 99)
		    System.out.print (".");
	    } catch (IOException e) {
		e.printStackTrace (); 
	    }
	}
	System.out.println ();
	System.out.println ("press enter to exit");
	try {
	    System.in.read ();
	} catch (IOException e) {
	    e.printStackTrace ();
	}
    }
}
