package rabbit.cache;

// $Id: CacheStatus.java,v 1.8 2005/05/05 15:29:07 robo Exp $

import java.io.*;
import java.util.*;
import java.util.regex.*;
import java.util.zip.*;

import rabbit.http.*;
import rabbit.util.*;

/** A utility program to inspect the cache..
 */
public class CacheStatus 
{
    /* Constructor 
     */
    public CacheStatus () {
    }

    /** Run the cache inspector..
     * @param args The first element should be the cache directory to inspect.
     */
    public static void main (String[] args) {
	if (args.length < 1) {
	    System.err.println ("Must give cache directory...");
	    System.exit (-1);
	}
	NCache cache = new NCache (args[0]);
	boolean summary = false;
	Pattern pat = null;
	for (int i = 1; i < args.length; i++) {
	    if (args[i].equals ("-summary"))
		summary = true;
	    if (args[i].equals ("-matching")) {
		i++;
		if (i < args.length)
		    pat = Pattern.compile (args[i]);
	    }
	}
	if (summary) {
	    System.out.println ("Cachedir: " + args[0]);
	    System.out.println ("size: " + (cache.getCurrentSize () / (1024 * 1024))  + " MB");
	    System.out.println ("entries: " + cache.getNumberOfEntries ());
	    System.exit (0);
	}
	
	for (NCacheEntry ne : cache.getEntries ()) {
	    HTTPHeader header = (HTTPHeader)ne.getKey ();
	    if (pat != null) {
		Matcher m = pat.matcher (header.getRequestURI ());
		if (!m.find ())
		    continue;
	    }
	    HTTPHeader webheader = (HTTPHeader)ne.getDataHook (cache);
	    System.out.println ("ENTRY: " + cache.getEntryName (ne));
	    if (header == null)
		continue;
	    System.out.println (header.toString ());
	    System.out.println ("webheader");
	    System.out.println (webheader.toString ());
	    System.out.println ("================================================================");
	}
    }
}
