package rabbit.filter;

// $Id: BackgroundFilter.java,v 1.11 2005/08/02 20:50:21 robo Exp $

import rabbit.html.*;
import rabbit.http.HTTPHeader;
import rabbit.proxy.Connection;

/** This class removes background images from html pages.
 */
public class BackgroundFilter extends SimpleTagFilter {
    
    // for the factory part.
    public BackgroundFilter () {
    }

    /** Create a new BackgroundFilter for the given request, response pair.
     * @param con the Connection handling the request.
     * @param request the actual request made.
     * @param response the actual response being sent.
     */
    public BackgroundFilter (Connection con, HTTPHeader request, HTTPHeader response) {	
	super (con, request, response);
    }

    @Override public HTMLFilter newFilter (Connection con, 
					   HTTPHeader request, 
					   HTTPHeader response) {
	return new BackgroundFilter (con, request, response);
    }

    /** Remove background images from the given block.
     * @param tag the current Tag
     */
    public void handleTag (Tag tag, HTMLBlock block, int tokenIndex) {
	TagType type = tag.getTagType ();
	if (type == TagType.BODY || 
	    type == TagType.TABLE || 
	    type == TagType.TR || 
	    type == TagType.TD) {
	    tag.removeAttribute ("background");
	} 
    }
}
