package rabbit.filter;

// $Id: BlockFilter.java,v 1.7 2005/08/02 20:50:21 robo Exp $

import java.net.Socket;
import java.util.StringTokenizer;
import rabbit.http.HTTPHeader;
import rabbit.proxy.Connection;
import rabbit.util.Logger;
import rabbit.util.SProperties;

/** This is a class that blocks access to certain part of the www.
 */
public class BlockFilter implements HTTPFilter {
    private SProperties config = new SProperties ();
   
    /** 
     */
    public BlockFilter () {
    }
    
    /** test if a socket/header combination is valid or return a new HTTPHeader.
     * @param socket the Socket that made the request.
     * @param header the actual request made.
     * @param con the Connection handling the request.
     * @return null if everything is fine or a HTTPHeader describing the error (like a 403).
     */
    public HTTPHeader doHTTPInFiltering (Socket socket, HTTPHeader header, Connection con) {
	StringTokenizer st = new StringTokenizer (config.getProperty ("blockURLmatching", ""), ",");
	while (st.hasMoreTokens ()) {
	    if (header.getRequestURI ().indexOf (st.nextToken ()) > -1)
		return con.getResponseHandler ().get403 ();
	}	
	return null;
    }
    
    /** test if a socket/header combination is valid or return a new HTTPHeader.
     * @param socket the Socket that made the request.
     * @param header the actual request made.
     * @param con the Connection handling the request.
     * @return null if everything is fine or a HTTPHeader describing the error (like a 403).
     */
    public HTTPHeader doHTTPOutFiltering (Socket socket, HTTPHeader header, Connection con) {
	return null;
    }

    /** Setup this class with the given properties.
     * @param logger the Logger for errors/warnings
     * @param properties the new configuration of this class.
     */
    public void setup (Logger logger, SProperties properties) {
	config = properties;
    }
}
