package rabbit.io;

// $Id: Resolver.java,v 1.1 2005/08/02 20:50:21 robo Exp $

import java.net.InetAddress;
import java.net.URL;
import java.net.UnknownHostException;

public interface Resolver {
    /** Get the InetAddress for a given url. 
     *  Normally the InetAddress of the url host, but 
     *  might be the InetAddress of the chained proxy to use.
     */
    InetAddress getInetAddress (URL url) throws UnknownHostException;
    
    /** Get the port to use for connecting to a given port.
     *  Normally port is returned, but if there is a chained proxy, 
     *  then the proxy port is returned instead.
     */
    int getConnectPort (int port); 

    /** Check if the resolver is using a proxy or not. 
     */
    boolean isProxyConnected ();

    /** Get the currently set proxy authentication. 
     */
    String getProxyAuthString ();
}

