package rabbit.proxy;

// $Id: DNSJavaHandler.java,v 1.3 2005/08/02 20:50:21 robo Exp $

import java.net.InetAddress;
import java.net.URL;
import java.net.UnknownHostException;
import org.xbill.DNS.Address;
import org.xbill.DNS.Cache;
import org.xbill.DNS.DClass;
import org.xbill.DNS.Lookup;

/** A DNS handler using the dnsjava packages
 */
public class DNSJavaHandler implements DNSHandler {
    /** Do any neccessary setup. */
    public void setup (Proxy proxy) {
	String ct = proxy.getConfig ().getProperty (getClass ().getName (), 
						    "dnscachetime", "8").trim (); 
	int time = 8 * 3600; 
	try {
	    time = Integer.parseInt (ct) * 3600;
	} catch (NumberFormatException e) {
	    proxy.logError (Proxy.WARN, 
			    "bad number for dnscachetime: '" + ct + 
			    "', using: " + (time/3600) + " hours");
	}
	Cache dnsCache = Lookup.getDefaultCache (DClass.IN);
	dnsCache.setMaxCache (time);
	dnsCache.setMaxNCache (time);
    }

    /** Look up an internet address. */
    public InetAddress getInetAddress (URL url) throws UnknownHostException {
	return Address.getByName (url.getHost ());	
    }

    public InetAddress getInetAddress (String host) throws UnknownHostException {
	return Address.getByName (host);	
    }
}
