package rabbit.util;

// $Id: Counter.java,v 1.4 2005/08/02 20:50:21 robo Exp $

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

/** This class counts different messages
 */
public class Counter 
{
    // All the messages we count.
    private Map<String, Count> counters = 
	Collections.synchronizedMap (new HashMap<String, Count> ());
    
    /** This class holds one messages counts
     */
    static class Count 
    {
	private int counter = 0;
	
	/** Create a new Count
	 */
	Count () {
	}
	
	/** Increase its value by one
	 */
	void inc () {
	    counter++;
	}
	
	/** Get the count for this message
	 * @return the number of times this message has been counted.
	 */
	public int count () {
	    return counter;
	}
    }

    /** increase a logentry.
     * @param log the event to increase 
     */
    public void inc (String log) {
	Count l = counters.get(log);
	if (l == null) {
	    l = new Count ();
	    counters.put (log,l);
	}
	l.inc ();	
    }
    
    /** get all events
     * @return an Enumeration of all events
     */
    public Set<String> keys () {
	return counters.keySet ();
    }

    /** get the current count for an event.
     * @param key the event were intrested in
     * @return the current count of event.
     */
    public int get (String key) {
	Count l = counters.get (key);
	if (l == null)
	    return 0;
	else 
	    return l.count ();
    }
}

